target datalayout = "e-p:64:64:64-i1:8:8-i8:8:8-i16:16:16-i32:32:32-i64:64:64-f32:32:32-f64:64:64-v16:16:16-v24:32:32-v32:32:32-v48:64:64-v64:64:64-v96:128:128-v128:128:128-v192:256:256-v256:256:256-v512:512:512-v1024:1024:1024"
target triple = "spir64-unknown-unknown"

@var = addrspace(1) global [65536 x i8] zeroinitializer

; Function Attrs: nounwind readnone
declare spir_func i64 @__builtin_spirv_BuiltInGlobalLinearId() #0

; Function Attrs: nounwind readnone
declare spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalInvocationId() #0

; Function Attrs: nounwind
define spir_kernel void @get_max_size(i64 addrspace(1)* %size_ret) #1 {
  store i64 65536, i64 addrspace(1)* %size_ret, align 8
  ret void
}

; Function Attrs: nounwind
define spir_kernel void @writer(i8 addrspace(1)* %src) #1 {
  %call = call spir_func i64 @__builtin_spirv_BuiltInGlobalLinearId() #0
  %1 = getelementptr inbounds i8, i8 addrspace(1)* %src, i64 %call
  %2 = load i8, i8 addrspace(1)* %1, align 1
  %3 = call spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalInvocationId() #0
  %call1 = extractelement <3 x i64> %3, i32 0
  %4 = getelementptr inbounds [65536 x i8], [65536 x i8] addrspace(1)* @var, i64 0, i64 %call1
  store i8 %2, i8 addrspace(1)* %4, align 1
  ret void
}

; Function Attrs: nounwind
define spir_kernel void @reader(i8 addrspace(1)* %dest) #1 {
  %1 = call spir_func <3 x i64> @__builtin_spirv_BuiltInGlobalInvocationId() #0
  %call = extractelement <3 x i64> %1, i32 0
  %2 = getelementptr inbounds [65536 x i8], [65536 x i8] addrspace(1)* @var, i64 0, i64 %call
  %3 = load i8, i8 addrspace(1)* %2, align 1
  %call1 = call spir_func i64 @__builtin_spirv_BuiltInGlobalLinearId() #0
  %4 = getelementptr inbounds i8, i8 addrspace(1)* %dest, i64 %call1
  store i8 %3, i8 addrspace(1)* %4, align 1
  ret void
}

attributes #0 = { nounwind readnone }
attributes #1 = { nounwind }

!opencl.kernels = !{!0, !7, !11}
!IGCMetadata = !{!13}
!opencl.enable.FP_CONTRACT = !{}
!opencl.spir.version = !{!250}
!opencl.ocl.version = !{!250}
!opencl.used.extensions = !{!251}
!opencl.used.optional.core.features = !{!251}
!opencl.compiler.options = !{!252}

!0 = !{void (i64 addrspace(1)*)* @get_max_size, !1, !2, !3, !4, !5, !6}
!1 = !{!"kernel_arg_addr_space", i32 1}
!2 = !{!"kernel_arg_access_qual", !"none"}
!3 = !{!"kernel_arg_type", !"long*"}
!4 = !{!"kernel_arg_type_qual", !""}
!5 = !{!"kernel_arg_base_type", !"long*"}
!6 = !{!"kernel_arg_name", !"size_ret"}
!7 = !{void (i8 addrspace(1)*)* @writer, !1, !2, !8, !4, !9, !10}
!8 = !{!"kernel_arg_type", !"char*"}
!9 = !{!"kernel_arg_base_type", !"char*"}
!10 = !{!"kernel_arg_name", !"src"}
!11 = !{void (i8 addrspace(1)*)* @reader, !1, !2, !8, !4, !9, !12}
!12 = !{!"kernel_arg_name", !"dest"}
!13 = !{!"ModuleMD", !14, !15, !70, !131, !161, !177, !189, !199, !201, !202, !213, !214, !215, !216, !219, !220, !221, !222, !223, !224, !225, !226, !227, !228, !229, !230, !232, !236, !237, !238, !239, !240, !241, !114, !242, !243, !245, !248, !249}
!14 = !{!"isPrecise", i1 false}
!15 = !{!"compOpt", !16, !17, !18, !19, !20, !21, !22, !23, !24, !25, !26, !27, !28, !29, !30, !31, !32, !33, !34, !35, !36, !37, !38, !39, !40, !41, !42, !43, !44, !45, !46, !47, !48, !49, !50, !51, !52, !53, !54, !55, !56, !57, !58, !59, !60, !61, !62, !63, !64, !65, !66, !67, !68, !69}
!16 = !{!"DenormsAreZero", i1 false}
!17 = !{!"CorrectlyRoundedDivSqrt", i1 false}
!18 = !{!"OptDisable", i1 false}
!19 = !{!"MadEnable", i1 false}
!20 = !{!"NoSignedZeros", i1 false}
!21 = !{!"NoNaNs", i1 false}
!22 = !{!"FloatRoundingMode", i32 0}
!23 = !{!"FloatCvtIntRoundingMode", i32 3}
!24 = !{!"VISAPreSchedRPThreshold", i32 0}
!25 = !{!"SetLoopUnrollThreshold", i32 0}
!26 = !{!"UnsafeMathOptimizations", i1 false}
!27 = !{!"FiniteMathOnly", i1 false}
!28 = !{!"FastRelaxedMath", i1 false}
!29 = !{!"DashGSpecified", i1 false}
!30 = !{!"FastCompilation", i1 false}
!31 = !{!"UseScratchSpacePrivateMemory", i1 true}
!32 = !{!"RelaxedBuiltins", i1 false}
!33 = !{!"SubgroupIndependentForwardProgressRequired", i1 true}
!34 = !{!"GreaterThan2GBBufferRequired", i1 true}
!35 = !{!"GreaterThan4GBBufferRequired", i1 true}
!36 = !{!"DisableA64WA", i1 false}
!37 = !{!"ForceEnableA64WA", i1 false}
!38 = !{!"PushConstantsEnable", i1 true}
!39 = !{!"HasPositivePointerOffset", i1 false}
!40 = !{!"HasBufferOffsetArg", i1 false}
!41 = !{!"BufferOffsetArgOptional", i1 true}
!42 = !{!"HasSubDWAlignedPtrArg", i1 false}
!43 = !{!"replaceGlobalOffsetsByZero", i1 false}
!44 = !{!"forcePixelShaderSIMDMode", i32 0}
!45 = !{!"pixelShaderDoNotAbortOnSpill", i1 false}
!46 = !{!"UniformWGS", i1 false}
!47 = !{!"disableVertexComponentPacking", i1 false}
!48 = !{!"disablePartialVertexComponentPacking", i1 false}
!49 = !{!"PreferBindlessImages", i1 false}
!50 = !{!"UseBindlessMode", i1 false}
!51 = !{!"UseLegacyBindlessMode", i1 true}
!52 = !{!"disableMathRefactoring", i1 false}
!53 = !{!"atomicBranch", i1 false}
!54 = !{!"ForceMinSimdSizeForFastestCS", i1 false}
!55 = !{!"EnableFastestLinearScan", i1 false}
!56 = !{!"UseStatelessforPrivateMemory", i1 false}
!57 = !{!"EnableTakeGlobalAddress", i1 false}
!58 = !{!"IsLibraryCompilation", i1 false}
!59 = !{!"FastVISACompile", i1 false}
!60 = !{!"MatchSinCosPi", i1 false}
!61 = !{!"CaptureCompilerStats", i1 false}
!62 = !{!"EnableZEBinary", i1 false}
!63 = !{!"ExcludeIRFromZEBinary", i1 false}
!64 = !{!"allowDisableRematforCS", i1 false}
!65 = !{!"DisableIncSpillCostAllAddrTaken", i1 false}
!66 = !{!"DisableCPSOmaskWA", i1 false}
!67 = !{!"DisableFastestGopt", i1 false}
!68 = !{!"WaForceHalfPromotion", i1 false}
!69 = !{!"EnableUndefAlphaOutputAsRed", i1 true}
!70 = !{!"FuncMD", !71, !72, !127, !128, !129, !130}
!71 = !{!"FuncMDMap[0]", void (i64 addrspace(1)*)* @get_max_size}
!72 = !{!"FuncMDValue[0]", !73, !74, !78, !79, !80, !100, !106, !107, !108, !109, !110, !111, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121, !122, !123, !124, !125, !126}
!73 = !{!"localOffsets"}
!74 = !{!"workGroupWalkOrder", !75, !76, !77}
!75 = !{!"dim0", i32 0}
!76 = !{!"dim1", i32 0}
!77 = !{!"dim2", i32 0}
!78 = !{!"funcArgs"}
!79 = !{!"functionType", !"KernelFunction"}
!80 = !{!"rtInfo", !81, !82, !83, !84, !85, !86, !87, !88, !89, !90, !91, !92, !93, !94, !95, !99}
!81 = !{!"callableShaderType", !"NumberOfCallableShaderTypes"}
!82 = !{!"isContinuation", i1 false}
!83 = !{!"hasTraceRayPayload", i1 false}
!84 = !{!"hasHitAttributes", i1 false}
!85 = !{!"hasCallableData", i1 false}
!86 = !{!"ShaderStackSize", i32 0}
!87 = !{!"ShaderHash", i64 0}
!88 = !{!"ShaderName", !""}
!89 = !{!"ParentName", !""}
!90 = !{!"SlotNum", i1* null}
!91 = !{!"NOSSize", i32 0}
!92 = !{!"Entries"}
!93 = !{!"SpillUnions"}
!94 = !{!"CustomHitAttrSizeInBytes", i32 0}
!95 = !{!"Types", !96, !97, !98}
!96 = !{!"FrameStartTys"}
!97 = !{!"ArgumentTys"}
!98 = !{!"FullFrameTys"}
!99 = !{!"Aliases"}
!100 = !{!"resAllocMD", !101, !102, !103, !104, !105}
!101 = !{!"uavsNumType", i32 0}
!102 = !{!"srvsNumType", i32 0}
!103 = !{!"samplersNumType", i32 0}
!104 = !{!"argAllocMDList"}
!105 = !{!"inlineSamplersMD"}
!106 = !{!"maxByteOffsets"}
!107 = !{!"IsInitializer", i1 false}
!108 = !{!"IsFinalizer", i1 false}
!109 = !{!"CompiledSubGroupsNumber", i32 0}
!110 = !{!"hasInlineVmeSamplers", i1 false}
!111 = !{!"localSize", i32 0}
!112 = !{!"localIDPresent", i1 false}
!113 = !{!"groupIDPresent", i1 false}
!114 = !{!"privateMemoryPerWI", i32 0}
!115 = !{!"globalIDPresent", i1 false}
!116 = !{!"hasSyncRTCalls", i1 false}
!117 = !{!"hasNonKernelArgLoad", i1 false}
!118 = !{!"hasNonKernelArgStore", i1 false}
!119 = !{!"hasNonKernelArgAtomic", i1 false}
!120 = !{!"UserAnnotations"}
!121 = !{!"m_OpenCLArgAddressSpaces"}
!122 = !{!"m_OpenCLArgAccessQualifiers"}
!123 = !{!"m_OpenCLArgTypes"}
!124 = !{!"m_OpenCLArgBaseTypes"}
!125 = !{!"m_OpenCLArgTypeQualifiers"}
!126 = !{!"m_OpenCLArgNames"}
!127 = !{!"FuncMDMap[1]", void (i8 addrspace(1)*)* @writer}
!128 = !{!"FuncMDValue[1]", !73, !74, !78, !79, !80, !100, !106, !107, !108, !109, !110, !111, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121, !122, !123, !124, !125, !126}
!129 = !{!"FuncMDMap[2]", void (i8 addrspace(1)*)* @reader}
!130 = !{!"FuncMDValue[2]", !73, !74, !78, !79, !80, !100, !106, !107, !108, !109, !110, !111, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121, !122, !123, !124, !125, !126}
!131 = !{!"pushInfo", !132, !133, !134, !137, !138, !139, !140, !141, !142, !143, !144, !157, !158, !159, !160}
!132 = !{!"pushableAddresses"}
!133 = !{!"bindlessPushInfo"}
!134 = !{!"dynamicBufferInfo", !135, !136}
!135 = !{!"firstIndex", i32 0}
!136 = !{!"numOffsets", i32 0}
!137 = !{!"MaxNumberOfPushedBuffers", i32 0}
!138 = !{!"inlineConstantBufferSlot", i32 -1}
!139 = !{!"inlineConstantBufferOffset", i32 -1}
!140 = !{!"inlineConstantBufferGRFOffset", i32 -1}
!141 = !{!"constants"}
!142 = !{!"inputs"}
!143 = !{!"constantReg"}
!144 = !{!"simplePushInfoArr", !145, !154, !155, !156}
!145 = !{!"simplePushInfoArrVec[0]", !146, !147, !148, !149, !150, !151, !152, !153}
!146 = !{!"cbIdx", i32 0}
!147 = !{!"pushableAddressGrfOffset", i32 -1}
!148 = !{!"pushableOffsetGrfOffset", i32 -1}
!149 = !{!"offset", i32 0}
!150 = !{!"size", i32 0}
!151 = !{!"isStateless", i1 false}
!152 = !{!"isBindless", i1 false}
!153 = !{!"simplePushLoads"}
!154 = !{!"simplePushInfoArrVec[1]", !146, !147, !148, !149, !150, !151, !152, !153}
!155 = !{!"simplePushInfoArrVec[2]", !146, !147, !148, !149, !150, !151, !152, !153}
!156 = !{!"simplePushInfoArrVec[3]", !146, !147, !148, !149, !150, !151, !152, !153}
!157 = !{!"simplePushBufferUsed", i32 0}
!158 = !{!"pushAnalysisWIInfos"}
!159 = !{!"inlineRTGlobalPtrOffset", i32 0}
!160 = !{!"rtSyncSurfPtrOffset", i32 0}
!161 = !{!"psInfo", !162, !163, !164, !165, !166, !167, !168, !169, !170, !171, !172, !173, !174, !175, !176}
!162 = !{!"BlendStateDisabledMask", i8 0}
!163 = !{!"SkipSrc0Alpha", i1 false}
!164 = !{!"DualSourceBlendingDisabled", i1 false}
!165 = !{!"ForceEnableSimd32", i1 false}
!166 = !{!"outputDepth", i1 false}
!167 = !{!"outputStencil", i1 false}
!168 = !{!"outputMask", i1 false}
!169 = !{!"blendToFillEnabled", i1 false}
!170 = !{!"forceEarlyZ", i1 false}
!171 = !{!"hasVersionedLoop", i1 false}
!172 = !{!"forceSingleSourceRTWAfterDualSourceRTW", i1 false}
!173 = !{!"NumSamples", i8 0}
!174 = !{!"blendOptimizationMode"}
!175 = !{!"colorOutputMask"}
!176 = !{!"WaDisableVRS", i1 false}
!177 = !{!"csInfo", !178, !179, !180, !181, !182, !24, !25, !183, !184, !185, !186, !187, !53, !188}
!178 = !{!"maxWorkGroupSize", i32 0}
!179 = !{!"waveSize", i32 0}
!180 = !{!"ComputeShaderSecondCompile"}
!181 = !{!"forcedSIMDSize", i8 0}
!182 = !{!"forceTotalGRFNum", i32 0}
!183 = !{!"forcedVISAPreRAScheduler", i1 false}
!184 = !{!"disableLocalIdOrderOptimizations", i1 false}
!185 = !{!"disableDispatchAlongY", i1 false}
!186 = !{!"neededThreadIdLayout", i1* null}
!187 = !{!"forceTileYWalk", i1 false}
!188 = !{!"ResForHfPacking"}
!189 = !{!"msInfo", !190, !191, !192, !193, !194, !195, !196, !197, !198}
!190 = !{!"PrimitiveTopology", i32 3}
!191 = !{!"MaxNumOfPrimitives", i32 0}
!192 = !{!"MaxNumOfVertices", i32 0}
!193 = !{!"MaxNumOfPerPrimitiveOutputs", i32 0}
!194 = !{!"MaxNumOfPerVertexOutputs", i32 0}
!195 = !{!"WorkGroupSize", i32 0}
!196 = !{!"WorkGroupMemorySizeInBytes", i32 0}
!197 = !{!"IndexFormat", i32 6}
!198 = !{!"SubgroupSize", i32 0}
!199 = !{!"taskInfo", !200, !195, !196, !198}
!200 = !{!"MaxNumOfOutputs", i32 0}
!201 = !{!"NBarrierCnt", i32 0}
!202 = !{!"rtInfo", !203, !204, !205, !206, !207, !208, !209, !210, !211, !212}
!203 = !{!"RayQueryAllocSizeInBytes", i32 0}
!204 = !{!"NumContinuations", i32 -1}
!205 = !{!"RTAsyncStackAddrspace", i32 -1}
!206 = !{!"RTAsyncStackSurfaceStateOffset", i1* null}
!207 = !{!"SWHotZoneAddrspace", i32 -1}
!208 = !{!"SWHotZoneSurfaceStateOffset", i1* null}
!209 = !{!"SWStackAddrspace", i32 -1}
!210 = !{!"SWStackSurfaceStateOffset", i1* null}
!211 = !{!"RTSyncStackAddrspace", i32 -1}
!212 = !{!"RTSyncStackSurfaceStateOffset", i1* null}
!213 = !{!"CurUniqueIndirectIdx", i32 0}
!214 = !{!"inlineDynTextures"}
!215 = !{!"inlineResInfoData"}
!216 = !{!"immConstant", !217, !218}
!217 = !{!"data"}
!218 = !{!"sizes"}
!219 = !{!"inlineConstantBuffers"}
!220 = !{!"inlineGlobalBuffers"}
!221 = !{!"GlobalPointerProgramBinaryInfos"}
!222 = !{!"ConstantPointerProgramBinaryInfos"}
!223 = !{!"GlobalBufferAddressRelocInfo"}
!224 = !{!"ConstantBufferAddressRelocInfo"}
!225 = !{!"forceLscCacheList"}
!226 = !{!"SrvMap"}
!227 = !{!"RasterizerOrderedByteAddressBuffer"}
!228 = !{!"MinNOSPushConstantSize", i32 0}
!229 = !{!"inlineProgramScopeOffsets"}
!230 = !{!"shaderData", !231}
!231 = !{!"numReplicas", i32 0}
!232 = !{!"URBInfo", !233, !234, !235}
!233 = !{!"has64BVertexHeaderInput", i1 false}
!234 = !{!"has64BVertexHeaderOutput", i1 false}
!235 = !{!"hasVertexHeader", i1 true}
!236 = !{!"UseBindlessImage", i1 false}
!237 = !{!"enableRangeReduce", i1 false}
!238 = !{!"allowMatchMadOptimizationforVS", i1 false}
!239 = !{!"disableMemOptforNegativeOffsetLoads", i1 false}
!240 = !{!"statefulResourcesNotAliased", i1 false}
!241 = !{!"disableMixMode", i1 false}
!242 = !{!"PrivateMemoryPerFG"}
!243 = !{!"capabilities", !244}
!244 = !{!"globalVariableDecorationsINTEL", i1 false}
!245 = !{!"m_ShaderResourceViewMcsMask", !246, !247}
!246 = !{!"m_ShaderResourceViewMcsMaskVec[0]", i64 0}
!247 = !{!"m_ShaderResourceViewMcsMaskVec[1]", i64 0}
!248 = !{!"computedDepthMode", i32 0}
!249 = !{!"isHDCFastClearShader", i1 false}
!250 = !{i32 2, i32 0}
!251 = !{}
!252 = !{!"-cl-std=CL2.0"}
